'Ansteuerung eines Nokia 3510i Farb-Display
'Original von Martin Kuehn
'Zeichenausgabe mit lcd_doublesize 0=16x8 zeichen 12=8x4 Zeichen 2=16x4
'Copyright Stefan Horn - Dezember 2004

'Controller D15G14E_14_030526

'Atmega 128

'HWSTACK-256
'SWSTACK-256
'FRAMESIZE-256

'-------------------------------------------------------------------------------
'Display Pin 1 Reset => AVR Pin C0
'            2 CS               C1
'            3 GND              GND
'            4 Sdata            C2
'            5 Sclk             C3
'            6 Vdigital         Vdd (3 Volt)
'            7 Vbooster         Vdd
'            8 Vlcd             ber Elko (10uF/10V) an GND
'-------------------------------------------------------------------------------
'MMC pins in SPI mode:
'            Pin2               ChipSelect(SS)
'            Pin3               MMC input(MOSI)
'            Pin4               GND
'            Pin5               3V+
'            Pin6               Clock(SCK)
'            Pin7               GND
'            Pin8               MMC output(MISO)
'-------------------------------------------------------------------------------

$regfile = "m128def.dat"
$crystal = 8000000

'Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , Polarity = High , Phase = 1 , Clockrate = 128 , Noss = 1
'Spsr = 1                                                    'double speed
'Configure for software SPI
'                    MISO           MOSI             SS             SCK
Config Spi = Soft , Din = Pinb.3 , Dout = Portb.2 , Ss = Portb.0 , Clock = Portb.1

Declare Function Id3_nextfat(byval Aktfat As Long) As Long
Declare Sub Id3_readstring(byval Addr1 As Long , Byval Addr2 As Long , Byval Sector As Long)

Declare Sub Player_id3tag()
Declare Sub Player_mp3header()
Declare Function Player_mp3header2(byval Addr As Long) As Byte

Declare Sub Player_show_time()
Declare Sub Player_show_name()
Declare Sub Player_show_state()
Declare Sub Player_playfile()
Declare Sub Player_transfersector(byval Addr As Long)

Declare Sub Mmc_init()
Declare Sub Mmc_fat_init()
Declare Sub Mmc_searchfiles(byval Filenr As Long)
Declare Sub Mmc_command(byval Cmd_1 As Byte , Byval Addr As Long , Byval Cmd_2 As Byte )
Declare Sub Mmc_rsector(byval Addr As Long)

Declare Sub Lcd_init
Declare Sub Lcd_cls
Declare Sub Lcd_setcolor(byval Forecolor As Byte , Byval Backcolor As Byte)
Declare Sub Lcd_setdoublesize(byval Size As Byte)
Declare Sub Lcd_setframe(byval Lcd_left As Byte , Byval Lcd_top As Byte , Byval Lcd_width As Byte , Byval Lcd_height As Byte)
Declare Sub Lcd_sendbyte(byval Lcd_command As Byte , Byval Lcd_data As Byte)
Declare Sub Lcd_locate(byval Lcd_x As Byte , Byval Lcd_y As Byte)
Declare Sub Lcd_print(byval Lcd_text As String)

Declare Sub Mp3_init()
Declare Sub Mp3_volume(byval Vol As Byte )

Dim Volume As Byte

Dim Lcd_doublesize As Byte
Dim Lcd_posx As Byte
Dim Lcd_posy As Byte
Dim Lcd_fcolor As Byte
Dim Lcd_bcolor As Byte
Dim Mmc_dat(1024) As Byte
Dim Mmc_sec(512) As Byte
Dim Mmc_dir(512) As Byte

Dim Al As Long
Dim Fat As Long
Dim Verz As Long
Dim Dat As Long
Dim Secpercluster As Long
Dim Pointer_fat As Long
Dim Pointer_cluster As Long
Dim Filelen As Long
Dim Playlen As Long
Dim Block As Long

Dim Mpeg As Byte
Dim Layer As Byte
Dim Bitrate As Long
Dim Sampling As Long
Dim Playtime_m As Long
Dim Playtime_s As Long
Dim Id3len As Long
Dim Titel As String * 16
Dim Interpret As String * 16
Dim Album As String * 16

Dim Key As Byte

Dim Mmc_files As Long
Dim Fat_eintrag As Long
Dim First_fat As Long
Dim Play_item As Long
Dim Filename As String * 12
Dim Playstate As Byte                                       '0-stop,1-play,2-zurck,3-vor)
Dim Volumeset As Byte

Dim Mas_count As Long
Dim I2c_buffer(4) As Byte

P_ddr Alias Ddrc
P_out Alias Portc

Mmc_p Alias Portb
Const Mmc_clk = 1

Key_ddr Alias Ddra
Key_in Alias Pina
Const Key_play = 4
Const Key_stop = 5
Const Key_for = 6
Const Key_back = 7

Clk Alias Portb.1
Miso Alias Pinb.3                                           'inp
Mosi Alias Portb.2                                          'out                                      'out
Const Msbl = 0
Const Msbh = 1

Const Mmc_cs = 4
Const Mmc_en = 5

Const P_io = &B11111111
Const Lcd_rs = 0
Const Lcd_cs = 1
Const Lcd_sdata = 2
Const Lcd_sclk = 3

Const Mp3_sdata = 6
Const Mp3_sclk = 7

Const Lcd_cmd = 0
Const Lcd_prm = 1

Config Timer1 = Timer , Prescale = 1024
Dim Zehner As Byte
Dim Sekunde As Byte
Dim Minute As Byte
Dim Ssekunde As Byte
Dim Mminute As Byte
Dim Timepointer As Byte
On Timer1 Timer1int
Load Timer1 , 7812
Enable Interrupts
Enable Timer1

$eeprom
Data &H00 , &H00 , &H00 , &H00 , &H00                       ' "(space)"
Data &H00 , &H06 , &H5F , &H06 , &H00                       ' "!"
Data &H07 , &H03 , &H00 , &H07 , &H03' """
Data &H24 , &H7E , &H24 , &H7E , &H24                       ' "#"
Data &H24 , &H2B , &H6A , &H12 , &H00                       ' "$"
Data &H63 , &H13 , &H08 , &H64 , &H63                       ' "%"
Data &H36 , &H49 , &H56 , &H20 , &H50                       ' "&"
Data &H00 , &H07 , &H03 , &H00 , &H00                       ' "'"
'40
Data &H00 , &H3E , &H41 , &H00 , &H00                       ' "("
Data &H00 , &H41 , &H3E , &H00 , &H00                       ' ")"
Data &H08 , &H3E , &H1C , &H3E , &H08                       ' "*"
Data &H08 , &H08 , &H3E , &H08 , &H08                       ' "+"
Data &H00 , &HE0 , &H60 , &H00 , &H00                       ' ","
Data &H08 , &H08 , &H08 , &H08 , &H08                       ' "-"
Data &H00 , &H60 , &H60 , &H00 , &H00                       ' "."
Data &H20 , &H10 , &H08 , &H04 , &H02                       ' "/"
Data &H3E , &H51 , &H49 , &H45 , &H3E                       ' "0"
Data &H00 , &H42 , &H7F , &H40 , &H00                       ' "1"
'50
Data &H62 , &H51 , &H49 , &H49 , &H46                       ' "2"
Data &H22 , &H49 , &H49 , &H49 , &H36                       ' "3"
Data &H18 , &H14 , &H12 , &H7F , &H10                       ' "4"
Data &H2F , &H49 , &H49 , &H49 , &H31                       ' "5"
Data &H3C , &H4A , &H49 , &H49 , &H30                       ' "6"
Data &H01 , &H71 , &H09 , &H05 , &H03                       ' "7"
Data &H36 , &H49 , &H49 , &H49 , &H36                       ' "8"
Data &H06 , &H49 , &H49 , &H29 , &H1E                       ' "9"
Data &H00 , &H6C , &H6C , &H00 , &H00                       ' ":"
Data &H00 , &HEC , &H6C , &H00 , &H00                       ' ";"
'60
Data &H08 , &H14 , &H22 , &H41 , &H00                       ' "<"
Data &H24 , &H24 , &H24 , &H24 , &H24                       ' "="
Data &H00 , &H41 , &H22 , &H14 , &H08                       ' ">"
Data &H02 , &H01 , &H59 , &H09 , &H06                       ' "?"
Data &H3E , &H41 , &H5D , &H55 , &H1E                       ' "@"
Data &H7E , &H09 , &H09 , &H09 , &H7E                       ' "A"
Data &H7F , &H49 , &H49 , &H49 , &H36                       ' "B"
Data &H3E , &H41 , &H41 , &H41 , &H22                       ' "C"
Data &H7F , &H41 , &H41 , &H41 , &H3E                       ' "D"
Data &H7F , &H49 , &H49 , &H49 , &H41                       ' "E"
'70
Data &H7F , &H09 , &H09 , &H09 , &H01                       ' "F"
Data &H3E , &H41 , &H49 , &H49 , &H7A                       ' "G"
Data &H7F , &H08 , &H08 , &H08 , &H7F                       ' "H"
Data &H00 , &H41 , &H7F , &H41 , &H00                       ' "I"
Data &H30 , &H40 , &H40 , &H40 , &H3F                       ' "J"
Data &H7F , &H08 , &H14 , &H22 , &H41                       ' "K"
Data &H7F , &H40 , &H40 , &H40 , &H40                       ' "L"
Data &H7F , &H02 , &H04 , &H02 , &H7F                       ' "M"
Data &H7F , &H02 , &H04 , &H08 , &H7F                       ' "N"
Data &H3E , &H41 , &H41 , &H41 , &H3E                       ' "O"
Data &H7F , &H09 , &H09 , &H09 , &H06                       ' "P"
'80
Data &H3E , &H41 , &H51 , &H21 , &H5E                       ' "Q"
Data &H7F , &H09 , &H09 , &H19 , &H66                       ' "R"
Data &H26 , &H49 , &H49 , &H49 , &H32                       ' "S"
Data &H01 , &H01 , &H7F , &H01 , &H01                       ' "T"
Data &H3F , &H40 , &H40 , &H40 , &H3F                       ' "U"
Data &H1F , &H20 , &H40 , &H20 , &H1F                       ' "V"
Data &H3F , &H40 , &H3C , &H40 , &H3F                       ' "W"
Data &H63 , &H14 , &H08 , &H14 , &H63                       ' "X"
Data &H07 , &H08 , &H70 , &H08 , &H07                       ' "Y"
Data &H71 , &H49 , &H45 , &H43 , &H00                       ' "Z"
Data &H00 , &H7F , &H41 , &H41 , &H00                       ' "["
'90
Data &H02 , &H04 , &H08 , &H10 , &H20                       ' "\"
Data &H00 , &H41 , &H41 , &H7F , &H00                       ' "]"
Data &H04 , &H02 , &H01 , &H02 , &H04                       ' "^"
Data &H80 , &H80 , &H80 , &H80 , &H80                       ' "_"
Data &H00 , &H03 , &H07 , &H00 , &H00                       ' "`"
Data &H20 , &H54 , &H54 , &H54 , &H78                       ' "a"
Data &H7F , &H44 , &H44 , &H44 , &H38                       ' "b"
Data &H38 , &H44 , &H44 , &H44 , &H28                       ' "c"
Data &H38 , &H44 , &H44 , &H44 , &H7F                       ' "d"
Data &H38 , &H54 , &H54 , &H54 , &H18                       ' "e"
Data &H08 , &H7E , &H09 , &H09 , &H00                       ' "f"
'100
Data &H18 , &HA4 , &HA4 , &HA4 , &H7C                       ' "g"
Data &H7F , &H04 , &H04 , &H78 , &H00                       ' "h"
Data &H00 , &H00 , &H7D , &H00 , &H00                       ' "i"
Data &H40 , &H80 , &H84 , &H7D , &H00                       ' "j"
Data &H7F , &H10 , &H28 , &H44 , &H00                       ' "k"
Data &H00 , &H00 , &H7F , &H40 , &H00                       ' "l"
Data &H7C , &H04 , &H18 , &H04 , &H78                       ' "m"
Data &H7C , &H04 , &H04 , &H78 , &H00                       ' "n"
Data &H38 , &H44 , &H44 , &H44 , &H38                       ' "o"
Data &HFC , &H44 , &H44 , &H44 , &H38                       ' "p"
Data &H38 , &H44 , &H44 , &H44 , &HFC                       ' "q"
'110
Data &H44 , &H78 , &H44 , &H04 , &H08                       ' "r"
Data &H08 , &H54 , &H54 , &H54 , &H20                       ' "s"
Data &H04 , &H3E , &H44 , &H24 , &H00                       ' "t"
Data &H3C , &H40 , &H20 , &H7C , &H00                       ' "u"
Data &H1C , &H20 , &H40 , &H20 , &H1C                       ' "v"
Data &H3C , &H60 , &H30 , &H60 , &H3C                       ' "w"
Data &H6C , &H10 , &H10 , &H6C , &H00                       ' "x"
Data &H9C , &HA0 , &H60 , &H3C , &H00                       ' "y"
Data &H64 , &H54 , &H54 , &H4C , &H00                       ' "z"
Data &H08 , &H3E , &H41 , &H41 , &H00                       ' "{"
'120
Data &H00 , &H00 , &H7F , &H00 , &H00                       ' "|"
Data &H00 , &H41 , &H41 , &H3E , &H08                       ' "}"
Data &H02 , &H01 , &H02 , &H01 , &H00                       ' "~"

Data &H3F , &H21 , &H21 , &H21 , &H21                       ' "["
Data &H21 , &H21 , &H21 , &H21 , &H21
Data &H21 , &H21 , &H21 , &H21 . &H3F                       ' "]"
Data &H3F , &H3F , &H3F , &H3F , &H3F
Data &H3F , &H00 , &H00 , &H00 , &H00
$data

'-------------------------------------------------------------------------------
'Hauptprogramm
'-------------------------------------------------------------------------------
Hauptprogramm:

Dim Temp As Byte
Dim Tast As Long
Dim Ss As String * 32
'Dim Temp2 As Integer


   P_ddr = P_io
   Key_ddr = &H03

   Volume = 0

   Spiinit

   Call Lcd_init
   Call Lcd_setcolor(&Hff , &H0)
   Call Lcd_cls
   Call Lcd_setdoublesize(2)
   Call Lcd_locate(1 , 2)
   Call Lcd_print( "   MP3-PLAYER   ")
   Call Lcd_print( "      V1.0  ")
   Call Lcd_setdoublesize(0)
   Call Lcd_locate(1 , 8)
   Call Lcd_print( "VS1001:         ")
   Call Mp3_init
   Wait 1
   Call Lcd_locate(1 , 8)
   Call Lcd_print( "INIT MMC:       ")
   Call Mmc_init()
   Call Lcd_locate(11 , 8)
   Call Lcd_print( "OK   ")
   Wait 1
   Call Lcd_locate(1 , 8)
   Call Lcd_print( "INIT FAT:       ")
   Call Mmc_fat_init()
   Call Lcd_locate(11 , 8)
   Call Lcd_print( "OK   ")
   Wait 1
   Call Lcd_locate(1 , 8)
   Call Lcd_print( "SEARCHING FILES:")
   Call Lcd_print( "                ")
   Call Mmc_searchfiles(0)

   Bitrate = 0
   Sampling = 0
   Layer = 0
   Mpeg = 0
   Playtime_m = 0
   Playtime_s = 0
   Titel = ""
   Interpret = ""
   Album = ""

   Play_item = 1
   Playstate = 0
   Volumeset = 0

   Call Mp3_volume(&Hff)

   Call Mmc_searchfiles(play_item)

   Call Lcd_cls()
   Call Player_show_name()
   Call Player_show_state()

   'Play = 224
   'Stop = 208
   'Zurck = 176
   'Vor = 112

   '          Vor
   '          |Zurck
   '          ||Stop
   '          |||Play
   '          |||| Volume Up
   '          |||| |Volume Down
   '          |||| ||
   'Playstate 0000 00xx
   Do

      If Playstate = 0 Then
         If Key = 248 Then
            Volumeset = 1                                   'minus
            Goto Weiter1
         End If
         If Key = 244 Then
            Volumeset = 2                                   'plus
            Goto Weiter1
         End If
         While Key_in = &HFC
            Tast = 0
         Wend
         Key = Key_in And &HFC
         If Key = 236 Then Playstate = Playstate Or &B0001
         If Key = 188 Then Playstate = Playstate Or &B0100
         If Key = 124 Then Playstate = Playstate Or &B1000
         If Key = 220 Then Playstate = 0
         If Tast = 0 Then
            While Key_in <> &HFC
               Tast = Tast + 1
               If Tast > 50000 Then Exit While
            Wend
         End If
Weiter1:
         Key = 0
      Else
         If Volumeset = 1 Then
            If Volume < &HFE Then Volume = Volume + 1
            Call Mp3_volume(volume)
            Volumeset = 0
         End If
         If Volumeset = 2 Then
            If Volume > 0 Then Volume = Volume - 1
            Call Mp3_volume(volume)
            Volumeset = 0
         End If
         Temp = Playstate And &B1000
         If Temp = &B1000 Then
            Play_item = Play_item + 1
            If Play_item > Mmc_files Then Play_item = 1
            Call Mmc_searchfiles(play_item)
            Call Player_show_name()
            Playstate = Playstate And &B0111
         End If
         Temp = Playstate And &B0100
         If Temp = &B0100 Then
            Play_item = Play_item - 1
            If Play_item = 0 Then Play_item = Mmc_files
            Call Mmc_searchfiles(play_item)
            Call Player_show_name()
            Playstate = Playstate And &B1011
         End If
         Temp = Playstate And &B0001
         If Temp = &B0001 Then
            Call Player_id3tag()
            Call Player_mp3header()
            Call Player_show_name()
            Call Player_show_state()
            Zehner = 0
            Sekunde = 0
            Ssekunde = 0
            Minute = 0
            Mminute = 0
            Bitrate = 0
            Sampling = 0
            Layer = 0
            Mpeg = 0
            Playtime_m = 0
            Playtime_s = 0
            Titel = ""
            Interpret = ""
            Album = ""
            Playlen = 0
            Block = 0
            Call Mp3_volume(volume)
            Start Timer1
            Call Player_playfile()
            Stop Timer1
            Call Mp3_volume(&Hff)
            Call Mp3_init
            Call Player_show_state()
            If Playstate = 1 Then
               'nchster titel
               Play_item = Play_item + 1
               If Play_item > Mmc_files Then
                  Play_item = 1
                  Playstate = 0
               End If
               Call Mmc_searchfiles(play_item)
            End If
         End If
      End If
      If Playstate = 0 Then Call Mmc_searchfiles(play_item)
   Loop

End

'-------------------------------------------------------------------------------
'Play File
'-------------------------------------------------------------------------------
Timer1int:

   Load Timer1 , 7812
   Sekunde = Sekunde + 1
   If Sekunde = 10 Then
      Sekunde = 0
      Ssekunde = Ssekunde + 1
      If Ssekunde = 6 Then
         Ssekunde = 0
         Minute = Minute + 1
         If Minute = 10 Then
            Minute = 0
            Mminute = Mminute + 1
            If Mminute = 10 Then Mminute = 0

         End If
      End If
   End If

Return
'-------------------------------------------------------------------------------
'Play File
'-------------------------------------------------------------------------------
Sub Player_playfile()

Local A As Long
Local B As Long
Local C As Long
Local D As Long
Local R As Integer

   D = 0

   While Fat_eintrag < &HFFF7

      If Playlen > Filelen Then Exit While                  'dateiende erreicht?

      B = Fat_eintrag - 2
      B = B * Secpercluster                                 'berechne sector aus cluster
      B = B + Dat

      For R = 1 To Secpercluster                            'alle sectoren des clusters
         If Playstate > 1 Then Exit For
         If Playstate = 0 Then Exit For
         Call Player_transfersector(b)
         B = B + 1
      Next

      If Playstate > 1 Then Exit While
      If Playstate = 0 Then Exit While

      Shift , Fat_eintrag , Left , 1                        'korrektur von word auf byte
      Fat_eintrag = Fat_eintrag + 1

      Pointer_fat = 0

      While Fat_eintrag > 512                               'bestimme sector und position
         Pointer_fat = Pointer_fat + 1
         Fat_eintrag = Fat_eintrag - 512
      Wend
      A = Fat + Pointer_fat

      If A <> D Then
         D = A
         Call Mmc_rsector(a)                                'hole nchsten eintrag
      End If

      A = Mmc_dat(fat_eintrag + 1)
      Shift A , Left , 8
      B = Mmc_dat(fat_eintrag + 0)
      A = A + B
      Fat_eintrag = A

   Wend

End Sub

'-------------------------------------------------------------------------------
'Transfer Sector
'-------------------------------------------------------------------------------
Sub Player_transfersector(byval Addr As Long)

Local A As Byte
Local B As Byte
Local R As Integer
Local T As Integer
Local M As Byte

   Ddrd = &H00

   Reset P_out.mmc_cs

   Call Mmc_command(&H51 , Addr , &H95)
   Shiftin Miso , Clk , A , Msbl

   While A <> &HFE
      Shiftin Miso , Clk , A , Msbl
   Wend

   For R = 1 To 512
      'Shiftin Miso , Clk , A , Msbl
      While Pind.5 = 0
         If M <> Sekunde Then
            Timepointer = 0
            M = Sekunde
         Else
            If Timepointer < 10 Then Call Player_show_time
         End If
      Wend
      'Shiftout P_out.mp3_sdata , P_out.mp3_sclk , A , Msbl

      'warum erst lesen????
      'Dateneingang(vs1001) mit datenausgang(mmc) direkt verbunden
      '2x takt fr mmc und vs1001k
      'im 1.Bit Bytesync-signal

      If Playlen > Filelen Then
         'was nicht hingehrt, das woll'n wir nicht :D
         Shiftin Miso , Clk , A , Msbl
      Else
      $asm
         sbi   mmc_p,mmc_clk
         'sbi   P_out,mp3_sclk
         sbi   porte,1
         sbi   porte,0
         nop
         '1
         cbi   mmc_p,mmc_clk
         'cbi   P_out,mp3_sclk
         cbi   porte,1
         nop
         sbi   mmc_p,mmc_clk
         'sbi   P_out,mp3_sclk
         sbi   porte,1
         cbi   porte,0
         nop
         '2
         cbi   mmc_p,mmc_clk
         'cbi   P_out,mp3_sclk
         cbi   porte,1
         nop
         sbi   mmc_p,mmc_clk
         'sbi   P_out,mp3_sclk
         sbi   porte,1
         nop
         '3
         cbi   mmc_p,mmc_clk
         'cbi   P_out,mp3_sclk
         cbi   porte,1
         nop
         sbi   mmc_p,mmc_clk
         'sbi   P_out,mp3_sclk
         sbi   porte,1
         nop
         '4
         cbi   mmc_p,mmc_clk
         'cbi   P_out,mp3_sclk
         cbi   porte,1
         nop
         sbi   mmc_p,mmc_clk
         'sbi   P_out,mp3_sclk
         sbi   porte,1
         nop
         '5
         cbi   mmc_p,mmc_clk
         'cbi   P_out,mp3_sclk
         cbi   porte,1
         nop
         sbi   mmc_p,mmc_clk
         'sbi   P_out,mp3_sclk
         sbi   porte,1
         nop
         '6
         cbi   mmc_p,mmc_clk
         'cbi   P_out,mp3_sclk
         cbi   porte,1
         nop
         sbi   mmc_p,mmc_clk
         'sbi   P_out,mp3_sclk
         sbi   porte,1
         nop
         '7
         cbi   mmc_p,mmc_clk
         'cbi   P_out,mp3_sclk
         cbi   porte,1
         nop
         sbi   mmc_p,mmc_clk
         'sbi   P_out,mp3_sclk
         sbi   porte,1
         nop
         '8
         cbi   mmc_p,mmc_clk
         'cbi   P_out,mp3_sclk
         cbi   porte,1
         nop
         sbi   mmc_p,mmc_clk
         'sbi   P_out,mp3_sclk
         sbi   porte,1
      $end Asm

      Playlen = Playlen + 1
      End If

   Next

   Shiftin Miso , Clk , A , Msbl
   Shiftin Miso , Clk , A , Msbl

   Set P_out.mmc_cs

   If Key_in <> &HFC Then
      Key = Key_in And &HFC
      'pause hier rein
      If Key = 248 Then
         If Volume < &HFE Then Volume = Volume + 1
         Call Mp3_volume(volume)
         Goto Weiter2
      End If
      If Key = 244 Then
         If Volume > 0 Then Volume = Volume - 1
         Call Mp3_volume(volume)
         Goto Weiter2
      End If
      If Key = 236 Then
         Stop Timer1
         While Key_in = 236
            nop
         Wend
         Call Lcd_setdoublesize(2)
         Call Lcd_locate(1 , 4)
         Call Lcd_print( "PSD ")
         While Key_in = &HFC
            nop
         Wend
         While Key_in <> &HFC
            nop
         Wend
         Key = Key_in And &HFC
         Call Lcd_locate(1 , 4)
         Call Lcd_print( "PLAY")
         Start Timer1
      End If
      If Key = 188 Then Playstate = Playstate Or &B0100
      If Key = 124 Then Playstate = Playstate Or &B1000
      If Key = 220 Then Playstate = 0

      While Key_in <> &HFC
         nop
      Wend
Weiter2:
   End If

End Sub

'-------------------------------------------------------------------------------
'Anzeige
'-------------------------------------------------------------------------------
Sub Player_show_name()

Local S As String * 13
Local A As Long

   Call Lcd_setdoublesize(0)
   Call Lcd_locate(1 , 1)
   Call Lcd_print( "         ")

   Call Lcd_locate(1 , 2)

   A = Bitrate / 1000
   S = Str(a)
   S = Format(s , "000")
   Call Lcd_print(s)
   Call Lcd_print( "/")
   A = Sampling / 1000
   S = Str(a)
   S = Format(s , "00")
   Call Lcd_print(s)
   Call Lcd_print( "k  ")

   Call Lcd_setdoublesize(2)
   Call Lcd_locate(10 , 1)
   S = Str(play_item)
   S = Format(s , "000")
   Call Lcd_print(s)
   Call Lcd_print( "/")
   S = Str(mmc_files)
   S = Format(s , "000")
   Call Lcd_print(s)

   Call Lcd_setcolor(&Hff , &H90)

   Call Lcd_setdoublesize(0)

   Call Lcd_locate(1 , 3)
   Call Lcd_print( "                ")
   Call Lcd_locate(1 , 3)
   Call Lcd_print(filename)

   Call Lcd_setcolor(&Hff , &H2E)

   Call Lcd_locate(1 , 4)
   Call Lcd_print( "                ")
   Call Lcd_locate(1 , 4)
   Call Lcd_print(titel)

   Call Lcd_locate(1 , 5)
   Call Lcd_print( "                ")
   Call Lcd_locate(1 , 5)
   Call Lcd_print(interpret)

   Call Lcd_locate(1 , 6)
   Call Lcd_print( "                ")
   Call Lcd_locate(1 , 6)
   Call Lcd_print(album)

   Call Lcd_setcolor(&Hff , &H0)

End Sub

'-------------------------------------------------------------------------------
'Anzeige
'-------------------------------------------------------------------------------
Sub Player_show_time()

Local S As String * 16
Local A As Long

   Select Case Timepointer
   Case 0
      Call Lcd_setdoublesize(2)
   Case 1
      Call Lcd_locate(12 , 4)
   Case 2
      S = Str(mminute)
      Call Lcd_print(s)
   Case 3
      S = Str(minute)
      Call Lcd_print(s)
   Case 4
      Call Lcd_print( ":")
   Case 5
      S = Str(ssekunde)
      Call Lcd_print(s)
   Case 6
      S = Str(sekunde)
      Call Lcd_print(s)
   Case 7
      A = Filelen / 5
      A = Playlen / A
      Block = A
   Case 8
      Call Lcd_setdoublesize(0)
      Call Lcd_locate(6 , 8)
   Case 9
      S = Chr(130)
      For A = 1 To Block
         Call Lcd_print(s)
      Next
   End Select
   Timepointer = Timepointer + 1

End Sub

'-------------------------------------------------------------------------------
'Anzeige
'-------------------------------------------------------------------------------
Sub Player_show_state()

Local S As String * 2

   If Playstate = 0 Then
      Call Lcd_setdoublesize(2)
      Call Lcd_locate(1 , 4)
      Call Lcd_print( "STOP ")
   Else
      Call Lcd_setdoublesize(2)
      Call Lcd_locate(1 , 4)
      Call Lcd_print( "PLAY ")
   End If
   Call Lcd_locate(12 , 4)
   Call Lcd_print( "00:00")

   Call Lcd_setdoublesize(0)
   Call Lcd_locate(6 , 7)
   S = Str(playtime_m)
   S = Format(s , "00")
   Call Lcd_print(s)
   Call Lcd_print( ":")
   S = Str(playtime_s)
   S = Format(s , "00")
   Call Lcd_print(s)
   Call Lcd_print( " ")

   Call Lcd_locate(6 , 8)
   S = Chr(127)
   Call Lcd_print(s)
   S = Chr(128)
   Call Lcd_print(s)
   Call Lcd_print(s)
   Call Lcd_print(s)
   S = Chr(129)
   Call Lcd_print(s)
   Call Lcd_print( " ")

End Sub

'-------------------------------------------------------------------------------
'ID3
'-------------------------------------------------------------------------------
Function Id3_nextfat(byval Aktfat As Long)as Long

Local A As Long
Local B As Long
Local D As Long

   D = 0

   B = Aktfat - 2
   B = B * Secpercluster                                    'berechne sector aus cluster
   B = B + Dat

   Shift , Aktfat , Left , 1                                'korrektur von word auf byte
   Aktfat = Aktfat + 1

   Pointer_fat = 0

   While Aktfat > 512                                       'bestimme sector und position
      Pointer_fat = Pointer_fat + 1
      Aktfat = Aktfat - 512
   Wend

   A = Fat + Pointer_fat

   If A <> D Then
      D = A
      Call Mmc_rsector(a)                                   'hole nchsten eintrag
   End If

   A = Mmc_dat(aktfat + 1)
   Shift A , Left , 8
   B = Mmc_dat(aktfat + 0)
   A = A + B
   Id3_nextfat = A

End Function

'-------------------------------------------------------------------------------
'ID3
'-------------------------------------------------------------------------------
Sub Id3_readstring(byval Addr1 As Long , Byval Addr2 As Long , Byval Sector As Long)

Local A As Byte
Local B As Long
Local R As Integer

   Reset P_out.mmc_cs

   B = Addr1 - 2
   B = B * Secpercluster                                    'berechne sector aus cluster
   B = B + Dat
   Addr1 = B

   B = Addr2 - 2
   B = B * Secpercluster                                    'berechne sector aus cluster
   B = B + Dat
   Addr2 = B

   Sector = Sector - 1
   Addr1 = Addr1 + Sector

   Call Mmc_command(&H51 , Addr1 , &H95)
   Shiftin Miso , Clk , A , Msbl

   While A <> &HFE
      Shiftin Miso , Clk , A , Msbl
   Wend

   For R = 1 To 512
      Shiftin Miso , Clk , A , Msbl
      Mmc_dat(r) = A
   Next

   Shiftin Miso , Clk , A , Msbl
   Shiftin Miso , Clk , A , Msbl

   Sector = Sector + 1
   If Sector = Secpercluster Then
      Addr1 = Addr2
   Else
      Addr1 = Addr1 + 1
   End If

   Call Mmc_command(&H51 , Addr1 , &H95)
   Shiftin Miso , Clk , A , Msbl

   While A <> &HFE
      Shiftin Miso , Clk , A , Msbl
   Wend

   For R = 513 To 1024
      Shiftin Miso , Clk , A , Msbl
      Mmc_dat(r) = A
   Next

   Shiftin Miso , Clk , A , Msbl
   Shiftin Miso , Clk , A , Msbl

   Set P_out.mmc_cs

End Sub

'-------------------------------------------------------------------------------
'ID3
'-------------------------------------------------------------------------------
Sub Player_id3tag()

Local A As Long
Local B As Long
Local C As Long
Local D As Long
Local E As Long
Local F As Long
Local G As Long
Local H As Long
Local S As String * 13
Local Pointer As Long
Local Fframe As String * 4
Local Framelen As Long

   Id3len = 0

   'ID3TAG???? Wer den scheiss verhunnebibelt hat, der gehrt standrechtlich erschossen

   B = Fat_eintrag - 2
   B = B * Secpercluster                                    'berechne sector aus cluster
   B = B + Dat

   Call Mmc_rsector(b)
   A = Mmc_dat(1)
   S = Chr(a)
   A = Mmc_dat(2)
   S = S + Chr(a)
   A = Mmc_dat(3)
   S = S + Chr(a)

   S = Ucase(s)

   If S = "ID3" Then

      'id3v2
      A = Mmc_dat(7)
      B = Mmc_dat(8)
      C = Mmc_dat(9)
      D = Mmc_dat(10)

      'warum nur 7 bit??? hat das achte sich aus platzmangel vor den zug geschmissen?
      Id3len = A * &H200000
      A = B * &H4000
      Id3len = Id3len + A
      A = C * &H80
      Id3len = Id3len + A
      Id3len = Id3len + D

      'nicht schn, aber selten. weil es ber mehrere sectoren gehen kann :(

      A = Fat_eintrag
      B = Id3_nextfat(a)

      C = 1                                                 'aktueller sector
      H = 0
      D = 11                                                'durchsuchte bytes
      Pointer = 11

      Call Id3_readstring(a , B , C)                        'aktueller cluster,nchster cluster,aktueller sector)

      While D < Id3len

         'frame-bezeichnung
         E = Mmc_dat(pointer)
         Fframe = Chr(e)
         E = Mmc_dat(pointer + 1)
         Fframe = Fframe + Chr(e)
         E = Mmc_dat(pointer + 2)
         Fframe = Fframe + Chr(e)
         E = Mmc_dat(pointer + 3)
         Fframe = Fframe + Chr(e)

         Pointer = Pointer + 4
         D = D + 4

         'frame-lnge
         E = Mmc_dat(pointer)
         Framelen = E * &H4000
         E = Mmc_dat(pointer + 1)
         E = E * &H800
         Framelen = Framelen + E
         E = Mmc_dat(pointer + 2)
         E = E * &H100
         Framelen = Framelen + E
         E = Mmc_dat(pointer + 3)
         Framelen = Framelen + E

         Pointer = Pointer + 7
         D = D + 7

         Select Case Fframe

         Case "TPE1"
            E = Mmc_dat(pointer)
            Interpret = Chr(e)
            If Framelen < 17 Then
               E = Framelen - 2
            Else
               E = 15
            End If
            For F = 1 To E
               G = F + Pointer
               G = Mmc_dat(g)
               Interpret = Interpret + Chr(g)
            Next
            H = H + 1

         Case "TIT2"
            E = Mmc_dat(pointer)
            Titel = Chr(e)
            If Framelen < 17 Then
               E = Framelen - 2
            Else
               E = 15
            End If
            For F = 1 To E
               G = F + Pointer
               G = Mmc_dat(g)
               Titel = Titel + Chr(g)
            Next
            H = H + 1

         Case "TALB"
            E = Mmc_dat(pointer)
            Album = Chr(e)
            If Framelen < 17 Then
               E = Framelen - 2
            Else
               E = 15
            End If
            For F = 1 To E
               G = F + Pointer
               G = Mmc_dat(g)
               Album = Album + Chr(g)
            Next
            H = H + 1

         End Select

         If H = 3 Then Exit While

         Pointer = Pointer + Framelen
         Pointer = Pointer - 1

         D = D + Framelen
         D = D - 1

         While Pointer > 512
            Pointer = Pointer - 512
            C = C + 1
            If C > Secpercluster Then
               A = B
               B = Id3_nextfat(b)
               C = 1
            End If
            Call Id3_readstring(a , B , C)                  'aktueller cluster,nchster cluster,aktueller sector)
         Wend

      Wend

   Else

      'id3v1?
      D = Filelen - 128                                     'minus der lnge der Eintrge
      E = 512 * Secpercluster
      Pointer = D / E                                       'anzahl der durchlufe fer fat-tabelle

      E = E * Pointer
      E = D - E                                             'restbetrag?
      E = E / 512                                           'anzahl der sectoren

      F = Fat_eintrag                                       'sichern

      C = 0

      While Pointer > 0                                     'dateiende erreicht?

         B = Fat_eintrag - 2
         B = B * Secpercluster                              'berechne sector aus cluster
         B = B + Dat

         Shift , Fat_eintrag , Left , 1                     'korrektur von word auf byte
         Fat_eintrag = Fat_eintrag + 1

         Pointer_fat = 0

         While Fat_eintrag > 512                            'bestimme sector und position
            Pointer_fat = Pointer_fat + 1
            Fat_eintrag = Fat_eintrag - 512
         Wend
         A = Fat + Pointer_fat

         If A <> C Then
            C = A
            Call Mmc_rsector(a)                             'hole nchsten eintrag
         End If

         A = Mmc_dat(fat_eintrag + 1)
         Shift A , Left , 8
         B = Mmc_dat(fat_eintrag + 0)
         A = A + B
         Fat_eintrag = A

         Pointer = Pointer - 1

      Wend

      G = Fat_eintrag

      E = E + 1
      If E > Secpercluster Then

         B = Fat_eintrag - 2
         B = B * Secpercluster                              'berechne sector aus cluster
         B = B + Dat

         Shift , Fat_eintrag , Left , 1                     'korrektur von word auf byte
         Fat_eintrag = Fat_eintrag + 1

         Pointer_fat = 0

         While Fat_eintrag > 512                            'bestimme sector und position
            Pointer_fat = Pointer_fat + 1
            Fat_eintrag = Fat_eintrag - 512
         Wend
         A = Fat + Pointer_fat

         If A <> C Then
            C = A
            Call Mmc_rsector(a)                             'hole nchsten eintrag
         End If

         A = Mmc_dat(fat_eintrag + 1)
         Shift A , Left , 8
         B = Mmc_dat(fat_eintrag + 0)
         A = A + B
         Fat_eintrag = A

      End If

      'falls doch ma passiert
      If Fat_eintrag > &HFFF6 Then Fat_eintrag = G

      Call Id3_readstring(g , Fat_eintrag , E)

      Pointer = 1
      S = ""

      While Pointer < 900
         A = Mmc_dat(pointer)
         B = Mmc_dat(pointer + 1)
         C = Mmc_dat(pointer + 2)
         S = Chr(a)
         S = S + Chr(b)
         S = S + Chr(c)
         S = Ucase(s)
         If S = "TAG" Then Exit While
         Pointer = Pointer + 1
      Wend

      If S = "TAG" Then

         Pointer = Pointer + 3
         'titel
         A = Mmc_dat(pointer)
         Titel = Chr(a)
         For B = 1 To 15
            D = B + Pointer
            A = Mmc_dat(d)
            Titel = Titel + Chr(a)
         Next

         Pointer = Pointer + 30
         'interpret
         A = Mmc_dat(pointer)
         Interpret = Chr(a)
         For B = 1 To 15
            D = B + Pointer
            A = Mmc_dat(d)
            Interpret = Interpret + Chr(a)
         Next

         Pointer = Pointer + 30
         'album
         A = Mmc_dat(pointer)
         Album = Chr(a)
         For B = 1 To 15
            D = B + Pointer
            A = Mmc_dat(d)
            Album = Album + Chr(a)
         Next

      End If

      Fat_eintrag = F

   End If

End Sub

'-------------------------------------------------------------------------------
'header1
'-------------------------------------------------------------------------------
Sub Player_mp3header()

Local A As Long
Local B As Long
Local C As Long
Local D As Long
Local E As Long
Local F As Byte
Local G As Long
Local R As Integer

   E = Fat_eintrag
   D = 0
   G = 0

   While Fat_eintrag < &HFFF7                               'dateiende erreicht?

      B = Fat_eintrag - 2
      B = B * Secpercluster                                 'berechne sector aus cluster
      B = B + Dat

      For R = 1 To Secpercluster                            'alle sectoren des clusters
         A = Id3len
         If G > A Then
            F = Player_mp3header2(b)
            If F = 1 Then Exit For
         End If
         G = G + 512
         B = B + 1
      Next

      If F = 1 Then Exit While

      Shift , Fat_eintrag , Left , 1                        'korrektur von word auf byte
      Fat_eintrag = Fat_eintrag + 1

      Pointer_fat = 0

      While Fat_eintrag > 512                               'bestimme sector und position
         Pointer_fat = Pointer_fat + 1
         Fat_eintrag = Fat_eintrag - 512
      Wend
      A = Fat + Pointer_fat

      If A <> D Then
         D = A
         Call Mmc_rsector(a)                                'hole nchsten eintrag
      End If

      A = Mmc_dat(fat_eintrag + 1)
      Shift A , Left , 8
      B = Mmc_dat(fat_eintrag + 0)
      A = A + B
      Fat_eintrag = A

   Wend

   Fat_eintrag = E

End Sub

'-------------------------------------------------------------------------------
'Header2
'-------------------------------------------------------------------------------
Function Player_mp3header2(byval Addr As Long)as Byte

Local A As Byte
Local B As Long
Local E As Long
Local R As Integer
Local Framesize As Long
Local Frames As Long
Local Lenght As Long

   Bitrate = 0
   Sampling = 0
   Layer = 0
   Mpeg = 0
   Playtime_m = 0
   Playtime_s = 0

   Call Mmc_rsector(addr)
                                                            'suche header
   For R = 1 To 508
      E = Mmc_dat(r)
      Shift E , Left , 8
      A = Mmc_dat(r + 1)
      E = E + A
      E = E And &HFFE0
      If E = &HFFE0 Then Exit For
   Next

   Player_mp3header2 = 0

   If E = &HFFE0 Then

      'nu geht da los
      'hole header
      E = Mmc_dat(r)
      Shift E , Left , 8
      A = Mmc_dat(r + 1)
      E = E + A
      Shift E , Left , 8
      A = Mmc_dat(r + 2)
      E = E + A
      Shift E , Left , 8
      A = Mmc_dat(r + 3)
      E = E + A
      'mpeg
      '00000000 00011000 00000000 00000000
      B = E And &H180000
      Shift B , Right , 19
      A = B And &H01
      If A = 1 Then Mpeg = 1
      If A = 0 Then Mpeg = 2
      A = B And &H02
      If A = 0 Then Mpeg = 4

      'layer
      '00000000 00000110 00000000 00000000
      B = E And &H60000
      Shift B , Right , 17
      Select Case B
         Case 1 : Layer = 3
         Case 2 : Layer = 2
         Case 3 : Layer = 1
      End Select
      'bitrate
      '00000000 00000000 11110000 00000000
      B = E And &HF000
      Shift B , Right , 12
      If Layer = 1 Then
         Select Case B
            Case 1 : Bitrate = 32
            Case 2 : Bitrate = 64
            Case 3 : Bitrate = 96
            Case 4 : Bitrate = 128
            Case 5 : Bitrate = 160
            Case 6 : Bitrate = 192
            Case 7 : Bitrate = 224
            Case 8 : Bitrate = 256
            Case 9 : Bitrate = 288
            Case 10 : Bitrate = 320
            Case 11 : Bitrate = 352
            Case 12 : Bitrate = 384
            Case 13 : Bitrate = 416
            Case 14 : Bitrate = 448
         End Select
      End If
      If Layer = 2 Then
         Select Case B
            Case 1 : Bitrate = 32
            Case 2 : Bitrate = 48
            Case 3 : Bitrate = 56
            Case 4 : Bitrate = 64
            Case 5 : Bitrate = 80
            Case 6 : Bitrate = 96
            Case 7 : Bitrate = 112
            Case 8 : Bitrate = 128
            Case 9 : Bitrate = 160
            Case 10 : Bitrate = 192
            Case 11 : Bitrate = 224
            Case 12 : Bitrate = 256
            Case 13 : Bitrate = 320
            Case 14 : Bitrate = 384
         End Select
      End If
      If Layer = 3 Then
         Select Case B
            Case 1 : Bitrate = 32
            Case 2 : Bitrate = 40
            Case 3 : Bitrate = 48
            Case 4 : Bitrate = 56
            Case 5 : Bitrate = 64
            Case 6 : Bitrate = 80
            Case 7 : Bitrate = 96
            Case 8 : Bitrate = 112
            Case 9 : Bitrate = 128
            Case 10 : Bitrate = 160
            Case 11 : Bitrate = 192
            Case 12 : Bitrate = 224
            Case 13 : Bitrate = 256
            Case 14 : Bitrate = 320
         End Select
      End If
      'sampling
      '00000000 00000000 00001100 00000000
      B = E And &HC00
      Shift B , Right , 10
      If Mpeg = 1 Then
         Select Case B
            Case 0 : Sampling = 44100
            Case 1 : Sampling = 48000
            Case 2 : Sampling = 32000
         End Select
      End If
      If Mpeg = 2 Then
         Select Case B
            Case 0 : Sampling = 22050
            Case 1 : Sampling = 24000
            Case 2 : Sampling = 16000
         End Select
      End If
      If Mpeg = 4 Then
         Select Case B
            Case 0 : Sampling = 11025
            Case 1 : Sampling = 12000
            Case 2 : Sampling = 8000
         End Select
      End If

      If Sampling <> 0 Then
         Bitrate = Bitrate * 1000
         Framesize = 144 * Bitrate
         Framesize = Framesize / Sampling
         Frames = Filelen / Framesize
         Lenght = Frames / 38

         Playtime_m = 0
         While Lenght > 60
            Playtime_m = Playtime_m + 1
            Lenght = Lenght - 60
         Wend
         Playtime_s = Lenght
      End If

      Player_mp3header2 = 1

      If Sampling = 0 Thenplayer_mp3header2 = 0
      If Bitrate = 0 Thenplayer_mp3header2 = 0
      If Mpeg = 0 Thenplayer_mp3header2 = 0
      If Layer = 0 Thenplayer_mp3header2 = 0

   End If

End Function

'-------------------------------------------------------------------------------
'Search Files
'-------------------------------------------------------------------------------
Sub Mmc_searchfiles(byval Filenr As Long )

Local A As Long
Local B As Byte
Local C As Byte
Local D As Byte
Local R As Integer
Local S As String * 3

   If Filenr = 0 Then
      Mmc_files = 0
      For R = 0 To 31                                       '32 Sectoren in Root
         A = Verz + R
         Call Mmc_rsector(a)
         For B = 0 To 15                                    '16 eintrge pro sector
            A = B
            A = A * 32
            A = A + 9
            C = Mmc_dat(a)
            S = Chr(c)

            A = A + 1
            C = Mmc_dat(a)
            S = S + Chr(c)

            A = A + 1
            C = Mmc_dat(a)
            S = S + Chr(c)

            S = Ucase(s)

            A = A - 10

            If S = "MP3" Then
               C = Mmc_dat(a)
               If C <> &HE5 Then
                  Mmc_files = Mmc_files + 1
                  Mmc_sec(mmc_files) = R
                  Mmc_dir(mmc_files) = B
               End If
            End If
         Next
      Next
   Else
      A = Verz
      A = A + Mmc_sec(filenr)
      Call Mmc_rsector(a)
      B = Mmc_dir(filenr)
      A = B
      A = A * 32

      'startcluster
      A = A + &H1C
      Fat_eintrag = Mmc_dat(a)
      Shift Fat_eintrag , Left , 8
      A = A - 1
      Fat_eintrag = Fat_eintrag + Mmc_dat(a)

      'filename
      A = B
      A = A * 32
      A = A + 1
      C = Mmc_dat(a)
      Filename = Chr(c)
      For D = 1 To 7
         A = A + 1
         C = Mmc_dat(a)
         Filename = Filename + Chr(c)
      Next
      Filename = Rtrim(filename)
      Filename = Filename + ".MP3"

      'filelen
      A = B
      A = A * 32
      A = A + &H1D
      Filelen = Mmc_dat(a + 3)
      Shift Filelen , Left , 8
      C = Mmc_dat(a + 2)
      Filelen = Filelen + C
      Shift Filelen , Left , 8
      C = Mmc_dat(a + 1)
      Filelen = Filelen + C
      Shift Filelen , Left , 8
      C = Mmc_dat(a)
      Filelen = Filelen + C

   End If

End Sub

'-------------------------------------------------------------------------------
'Fat Init
'-------------------------------------------------------------------------------
Sub Mmc_fat_init()

Local A As Byte

   Call Mmc_rsector(0)

   Fat = Mmc_dat(&H01c8)
   Shift Fat , Left , 8
   A = Mmc_dat(&H01c7)
   Fat = Fat + A

   Call Mmc_rsector(fat)

   Al = Mmc_dat(&H10)
   Shift Al , Left , 8
   A = Mmc_dat(&Hf)
   Al = Al + A
   Fat = Fat + Al

   Al = Mmc_dat(&H18)
   Shift Al , Left , 8
   A = Mmc_dat(&H17)
   Al = Al + A
   Shift Al , Left , 1
   Verz = Fat + Al

   Dat = Verz + 32

   Secpercluster = Mmc_dat(&H0e)

End Sub

'-------------------------------------------------------------------------------
'Read Sector
'-------------------------------------------------------------------------------
Sub Mmc_rsector(byval Addr As Long)

Local A As Byte
Local R As Integer

   Reset P_out.mmc_cs

   Call Mmc_command(&H51 , Addr , &H95)
   Shiftin Miso , Clk , A , Msbl

   While A <> &HFE
      Shiftin Miso , Clk , A , Msbl
   Wend

   For R = 1 To 512
      Shiftin Miso , Clk , A , Msbl
      Mmc_dat(r) = A
   Next

   Shiftin Miso , Clk , A , Msbl
   Shiftin Miso , Clk , A , Msbl

   Set P_out.mmc_cs

End Sub

'-------------------------------------------------------------------------------
'mmc init
'-------------------------------------------------------------------------------
Sub Mmc_init()

Local A As Byte
Local B As Byte
Local C As String * 4

Cmd0:

   Reset P_out.mmc_en
   Waitms 500
   Set P_out.mmc_en

   B = &HFF
   Set P_out.mmc_cs                                         'MMV Disabled

   For A = 1 To &H09
      Shiftout Mosi , Clk , B , Msbl
   Next
   Shiftout Mosi , Clk , B , Msbl , 2                       '74 mal takten

   Reset P_out.mmc_cs                                       'MMV Enabled

   For A = 1 To &H10
      Shiftout Mosi , Clk , B , Msbl                        '16 mal takten
   Next

   'CMD0
   Call Mmc_command(&H40 , 0 , &H95)
   Shiftin Miso , Clk , A , Msbl
   While A <> &H01
      Shiftin Miso , Clk , A , Msbl
   Wend

   Set P_out.mmc_cs
   Waitms 50
   Reset P_out.mmc_cs

   B = &HFF

Cmd55:

   'CMD55
   Call Mmc_command(&H77 , 0 , &H95)
   Shiftin Miso , Clk , A , Msbl
   While A <> &H01
      Shiftin Miso , Clk , A , Msbl
   Wend

   'Acmd41
   Call Mmc_command(&H69 , 0 , &H95)
   Shiftin Miso , Clk , A , Msbl
   While A <> &H01
      Shiftin Miso , Clk , A , Msbl
   Wend

   'CMD58
   Call Mmc_command(&H7a , 0 , &H95)
   Shiftin Miso , Clk , A , Msbl
   While A <> &H01
      Shiftin Miso , Clk , A , Msbl
   Wend

Cmd1:
   'CMD1
   Call Mmc_command(&H41 , 0 , &H95)
   Shiftin Miso , Clk , A , Msbl
   If A <> &H00 Then
      Shiftin Miso , Clk , A , Msbl
      If A <> &H00 Then Goto Cmd1
   End If

   Set P_out.mmc_cs                                         'MMV Disabled

End Sub

'-------------------------------------------------------------------------------
'MMC Send Command
'-------------------------------------------------------------------------------
Sub Mmc_command(byval Cmd_1 As Byte , Byval Addr As Long , Byval Cmd_2 As Byte )

Local B As Byte


   Addr = Addr * 512
   B = &HFF

   Shiftout Mosi , Clk , B , Msbl
   Shiftout Mosi , Clk , Cmd_1 , Msbl
   Shiftout Mosi , Clk , Addr , Msbl
   Shiftout Mosi , Clk , Cmd_2 , Msbl
   Shiftout Mosi , Clk , B , Msbl

End Sub

'-------------------------------------------------------------------------------
'Zeichenausgabe
'-------------------------------------------------------------------------------
Sub Lcd_cls

Local R As Integer

   Call Lcd_setframe(0 , 0 , 97 , 67)
   For R = 1 To 6566
      Call Lcd_sendbyte(lcd_prm , Lcd_bcolor)
   Next

End Sub

'-------------------------------------------------------------------------------
'Zeichenausgabe
'-------------------------------------------------------------------------------
Sub Lcd_print(byval Lcd_text As String)

Local R As Integer
Local A As Byte
Local B As Byte
Local C As Long
Local D As Byte
Local E As Byte
Local F As Byte
Local G As Long
Local Zeichen As String

   Call Lcd_sendbyte(lcd_cmd , &H36)                        'von oben nach unten zeichnen
   Call Lcd_sendbyte(lcd_prm , &B00100000)

   Call Lcd_sendbyte(lcd_cmd , &H2C)                        'Und wieder Daten

   For R = 1 To Len(lcd_text)

      Zeichen = Mid(lcd_text , R , 1)                       'Hole char
      G = Asc(zeichen)                                      'Bestimme Pos in Tabelle
      G = G - 32
      G = G * 5

      Readeeprom B , G

      Call Lcd_locate(lcd_posx , Lcd_posy)

      A = 8                                                 '1.linie frei
      If Lcd_doublesize = 1 Then A = 32
      If Lcd_doublesize = 2 Then A = 16
      While A > 0
         Call Lcd_sendbyte(lcd_prm , Lcd_bcolor)
         Decr A
      Wend

      'linie 2-6
      For F = 1 To 5
         C = 1
         If Lcd_doublesize = 1 Then C = C + 1               '2x ??
         While C > 0
            D = B                                           'Byte darf nicht verndert werden fr 2. durchlauf
            For E = 1 To 8
               A = D And 1
               If A = 1 Then
                  Call Lcd_sendbyte(lcd_prm , Lcd_fcolor)
                  If Lcd_doublesize > 0 Then Call Lcd_sendbyte(lcd_prm , Lcd_fcolor)
               Else
                  Call Lcd_sendbyte(lcd_prm , Lcd_bcolor)
                  If Lcd_doublesize > 0 Then Call Lcd_sendbyte(lcd_prm , Lcd_bcolor)
               End If
               Shift D , Right , 1
            Next
            Decr C
         Wend
         G = G + 1
         Readeeprom B , G
      Next

      Incr Lcd_posx
      If Lcd_doublesize = 1 Then
         If Lcd_posx > 8 Then
            Lcd_posx = 1
            Incr Lcd_posy
            If Lcd_posy > 4 Then Lcd_posy = 1
         End If
      Else
         If Lcd_posx > 16 Then
            Lcd_posx = 1
            Incr Lcd_posy
            If Lcd_posy > 8 Then Lcd_posy = 1
         End If
      End If

   Next

   Call Lcd_sendbyte(lcd_cmd , &H36)                        'und wieder von links nach rechts
   Call Lcd_sendbyte(lcd_prm , 0)

   Call Lcd_sendbyte(lcd_cmd , &H2C)                        'Und wieder Daten

End Sub

'-------------------------------------------------------------------------------
'Koordinatenfenster
'-------------------------------------------------------------------------------
Sub Lcd_locate(byval Lcd_x As Byte , Byval Lcd_y As Byte)

Local A As Byte
Local B As Byte
Local C As Byte
Local D As Byte

   Lcd_posx = Lcd_x
   Lcd_posy = Lcd_y

   If Lcd_doublesize = 1 Then
      A = Lcd_x - 1
      A = A * 12
      C = A + 11
      B = Lcd_y - 1
      B = B * 16
      B = B + 2
      D = B + 15
   Elseif Lcd_doublesize = 2 Then
      A = Lcd_x - 1
      A = A * 6
      C = A + 5
      B = Lcd_y - 1
      B = B * 16
      B = B + 2
      D = B + 15
   Else
      A = Lcd_x - 1
      A = A * 6
      C = A + 5
      B = Lcd_y - 1
      B = B * 8
      B = B + 2
      D = B + 7
   End If

   Call Lcd_setframe(a , B , C , D)

End Sub

'-------------------------------------------------------------------------------
'Frame
'-------------------------------------------------------------------------------
Sub Lcd_setframe(byval Lcd_left As Byte , Byval Lcd_top As Byte , Byval Lcd_width As Byte , Byval Lcd_height As Byte)

   Call Lcd_sendbyte(lcd_cmd , &H2A)
   Call Lcd_sendbyte(lcd_prm , Lcd_left)
   Call Lcd_sendbyte(lcd_prm , Lcd_width)
   'Set Lcd_out.lcd_cs                                       'Cs auf 1  Ende der Sequenz

   Call Lcd_sendbyte(lcd_cmd , &H2B)
   Call Lcd_sendbyte(lcd_prm , Lcd_top)
   Call Lcd_sendbyte(lcd_prm , Lcd_height)
   'Set Lcd_out.lcd_cs                                      'Cs auf 1  Ende der Sequenz

   Call Lcd_sendbyte(lcd_cmd , &H2C)                        'Und wieder Daten

End Sub

'-------------------------------------------------------------------------------
'Color
'-------------------------------------------------------------------------------
Sub Lcd_setcolor(byval Forecolor As Byte , Byval Backcolor As Byte)

   Lcd_fcolor = Forecolor
   Lcd_bcolor = Backcolor

End Sub

'-------------------------------------------------------------------------------
'Initialisierung (8bit-Modus)
'-------------------------------------------------------------------------------
Sub Lcd_setdoublesize(byval Size As Byte)

   Lcd_doublesize = Size

End Sub

'-------------------------------------------------------------------------------
'Initialisierung (8bit-Modus)
'-------------------------------------------------------------------------------
Sub Lcd_init

   Reset P_out.lcd_rs                                       'Initialisierung Reset
   Waitms 5
   Set P_out.lcd_rs

   Set P_out.lcd_cs
   Set P_out.lcd_sdata
   Set P_out.lcd_sclk

   Call Lcd_sendbyte(lcd_cmd , &H01)                        'Software Reset
   'Set Lcd_out.lcd_cs                                       'Cs auf 1  Ende der Sequenz
   Waitms 5

   Call Lcd_sendbyte(lcd_cmd , &H11)                        'Sleep out
   'Set Lcd_out.lcd_cs                                       'Cs auf 1  Ende der Sequenz

   Call Lcd_sendbyte(lcd_cmd , &H25)                        'Contrast
   Call Lcd_sendbyte(lcd_prm , 63)
   'Set Lcd_out.lcd_cs                                       'Cs auf 1  Ende der Sequenz

   Call Lcd_sendbyte(lcd_cmd , &H29)                        'Display ON
   'Set Lcd_out.lcd_cs                                       'Cs auf 1  Ende der Sequenz

   Call Lcd_sendbyte(lcd_cmd , &H03)                        'Booster voltage ON
   'Set Lcd_out.lcd_cs                                       'Cs auf 1  Ende der Sequenz
   Waitms 40

   Call Lcd_sendbyte(lcd_cmd , &H3A)                        'Interface pixel format 8 bit
   Call Lcd_sendbyte(lcd_prm , &H02)
   'Set Lcd_out.lcd_cs                                       'Cs auf 1  Ende der Sequenz

   Call Lcd_sendbyte(lcd_cmd , &H2D)                        'Colour set
   'Grn
   Call Lcd_sendbyte(lcd_prm , &H00)
   Call Lcd_sendbyte(lcd_prm , &H02)
   Call Lcd_sendbyte(lcd_prm , &H04)
   Call Lcd_sendbyte(lcd_prm , &H06)
   Call Lcd_sendbyte(lcd_prm , &H09)
   Call Lcd_sendbyte(lcd_prm , &H0B)
   Call Lcd_sendbyte(lcd_prm , &H0D)
   Call Lcd_sendbyte(lcd_prm , &H0F)
   'Rot
   Call Lcd_sendbyte(lcd_prm , &H00)
   Call Lcd_sendbyte(lcd_prm , &H02)
   Call Lcd_sendbyte(lcd_prm , &H04)
   Call Lcd_sendbyte(lcd_prm , &H06)
   Call Lcd_sendbyte(lcd_prm , &H09)
   Call Lcd_sendbyte(lcd_prm , &H0B)
   Call Lcd_sendbyte(lcd_prm , &H0D)
   Call Lcd_sendbyte(lcd_prm , &H0F)
   'Blau
   Call Lcd_sendbyte(lcd_prm , &H00)
   Call Lcd_sendbyte(lcd_prm , &H04)
   Call Lcd_sendbyte(lcd_prm , &H0B)
   Call Lcd_sendbyte(lcd_prm , &H0F)
   'Set Lcd_out.lcd_cs                                       'Cs auf 1  Ende der Sequenz

   Call Lcd_sendbyte(lcd_cmd , &H2C)                        'Und wieder Daten

   Lcd_doublesize = 0
   Lcd_posx = 1
   Lcd_posy = 1

End Sub

'-------------------------------------------------------------------------------
'bertragen eines Commandos oder eines Parameters / Datenbytes
'-------------------------------------------------------------------------------
Sub Lcd_sendbyte(byval Lcd_command As Byte , Byval Lcd_data As Byte)

Local R As Integer
Local A As Byte

   Reset P_out.lcd_cs                                       'Cs auf 0  Start der Sequenz

   If Lcd_command = Lcd_cmd Then

      Reset P_out.lcd_sclk
      Reset P_out.lcd_sdata                                 '0 fr Command
      Set P_out.lcd_sclk

   Else

      Reset P_out.lcd_sclk
      Set P_out.lcd_sdata                                   '1 fr Data
      Set P_out.lcd_sclk

   End If

   Shiftout P_out.lcd_sdata , P_out.lcd_sclk , Lcd_data , Msbl

   Set P_out.lcd_cs                                         'Cs auf 1  Ende der Sequenz

End Sub

'-------------------------------------------------------------------------------
'VS1001k
'-------------------------------------------------------------------------------
Sub Mp3_init()

   Local A As Byte
   Local R As Integer

   Ddrd = &H00

Nochma:

   Reset Porte.6
   Waitms 200
   Set Porte.6
   Waitms 200

   Reset Porte.5                                            'cs
   'soft reset
   A = 2
   Shiftout Porte.3 , Porte.4 , A , Msbl
   A = 0
   Shiftout Porte.3 , Porte.4 , A , Msbl
   A = 0
   Shiftout Porte.3 , Porte.4 , A , Msbl
   A = 4
   Shiftout Porte.3 , Porte.4 , A , Msbl

   Set Porte.5

   Waitms 2

   Reset Porte.5                                            'cs
   'bass treble enhance
   A = 2
   Shiftout Porte.3 , Porte.4 , A , Msbl
   A = 0
   Shiftout Porte.3 , Porte.4 , A , Msbl
   A = 0
   Shiftout Porte.3 , Porte.4 , A , Msbl
   A = 128
   Shiftout Porte.3 , Porte.4 , A , Msbl

   Set Porte.5

   Waitms 2

   R = 0
   While Pind.5 = 0
      R = R + 1
      If R > 10000 Then Exit While
   Wend

   If R > 10000 Then Goto Nochma

   Ddre = &HFF

   A = 0

   'For R = 1 To 1024
      Set Porte.0
      Shiftout Portd.0 , Porte.1 , Temp , Msbl , 1
      Reset Porte.0
      Shiftout Portd.0 , Porte.1 , Temp , Msbl , 7
   'Next

End Sub

'-------------------------------------------------------------------------------
'VS1001k
'-------------------------------------------------------------------------------
Sub Mp3_volume(byval Vol As Byte )

Local A As Byte

   Reset Porte.5                                            'cs
   A = 2
   Shiftout Porte.3 , Porte.4 , A , Msbl
   A = 11
   Shiftout Porte.3 , Porte.4 , A , Msbl
   Shiftout Porte.3 , Porte.4 , Vol , Msbl
   Shiftout Porte.3 , Porte.4 , Vol , Msbl

   Set Porte.5

End Sub